<?php

function theme_solr_search_page($results, $type) {
  global $pager_total_items;
  
  $items = array();
  $nids = array();
  if (!empty($results['results'])){
    foreach ($results['results'] as $entry) {
      $items[] = theme('solr_search_item', $entry, $type);
      if ($entry['nid']){
        $nids[] = $entry['nid'];
      }
    }
  }
  
  //if (!empty($nids)){
    //$interesting_terms = solr_interesting_terms($nids, $type);
  //}

  $output = array(
    theme('solr_facet_filters', $type, $_GET['fq']),
    sprintf('<div class="search-results-count">%s</div>', format_plural((int) $pager_total_items[0], '1 item found', '@count items found')),
    //$interesting_terms,
    '<div id="solr-facet-year"></div><div id="solr-facet-year-text"> </div>',
    theme('item_list', $items, NULL, 'ul', array('class' => 'search-results')),
    theme('pager', NULL, 20, 0), // FIXME: use $rows
    );
  return implode("\n", $output);
}

function theme_solr_search_item($item, $type) {
  $info = array();
  if ($item['type']) {
    $info[] = $item['type'];
  }
  if ($item['user']) {
    $info[] = $item['user'];
  }
  if ($item['date']) {
    //$info[] = format_date($item['date'], 'small');
    $info[] = format_interval(time() - $item['date'], 1) . t(' ago');
  }
  if (is_array($item['extra'])) {
    $info = array_merge($info, $item['extra']);
  }
    
  return sprintf('<div class="title"><a href="%s">%s</a></div><div class="info">%s</div><div class="body">%s</div>',
    check_url($item['link']),
    check_plain($item['title']),
    implode(' - ', $info),
    ($item['snippet'] ? $item['snippet'] : '')
    );
}

function theme_solr_facet($type, $name, $facet){
  $filter_fields = node_invoke($type, 'solr', 'filter_fields', $type);

  if ($result = node_invoke($type, 'solr', 'facet', $type, $name, array('facet' => $facet))){
    return $result;
  }
    
  $rows = array();
  foreach ($facet as $term => $count){
    $fq = "$name:\"$term\"";
    if ($_GET['fq']){
      $fq .= ' AND ' . $_GET['fq'];
    }
    
    $rows[]  = array(
      l($term, url("search/$type", sprintf('t=%s&fq=%s&df=%s', $_GET['t'], $fq, $_GET['df']), NULL, TRUE)),
      $count,
      ); 
  }
  
  return sprintf(
    '<div class="facet %s"><h2 class="facet-title">%s</h2>%s</div>',
    strtolower(str_replace(' ', '-', $filter_fields["$name"])),
    $filter_fields["$name"],
    theme('table', NULL, $rows, array(
      'id' => sprintf(
        'solr-facet-%s-table',
        strtolower(str_replace(' ', '-', $name))
        )
      ))
    );
}

function theme_solr_facet_filters($type, $fq){
  $items = array();
  if ($fq){
    if (preg_match_all('/(\w+\:\".*?\")/', $fq, $matches)){
      $all_filters = $matches[1];
      $filter_count = count($all_filters);
      for ($i = 0; $i < $filter_count; $i++){
        $filters = $all_filters;
        array_splice($filters, $i, 1);
        $items[] = check_plain($all_filters[$i]) . ' ' . l('x', "search/$type", array('class' => 'facet_filter'), sprintf('t=%s&fq=%s&df=%s', $_GET['t'], implode(' AND ', $filters), $_GET['df']));
      }
    }
  }
  return theme('item_list', array_unique($items));
}
