<?php

function solr_module_search_page($module, $type){  
  $terms = $_GET['t'];

  $output = array(drupal_get_form('solr_search_form', $terms, $type));

  if ($terms){
    drupal_add_css(drupal_get_path('module', 'solr') . '/solr.css');
    $results = module_invoke($module, 'solr', 'search', $type, $terms);

    if (empty($results)) {
      drupal_set_message(t('Your search yielded no results')); // FIXME: node_invoke('solr', 'empty');
    }
    else{
      $search_page = module_hook($module, 'search_page') ? module_invoke($module, 'search_page', $results, $type) : theme('solr_search_page', $results, $type);
      $output[] = theme('box', t('Search results'), $search_page);
    }
  }

  return implode("\n", $output);
}

function user_solr($op = 'search', $type, $keys = null, $params = array()) {
  switch ($op) {    
    case 'search':
      // Replace wildcards with MySQL/PostgreSQL wildcards.
      $keys = preg_replace('!\*+!', '%', $keys);

      $results['results'] = array();
      $result = pager_query("SELECT uid FROM {users} WHERE LOWER(name) LIKE LOWER('%%%s%%')", 15, 0, NULL, $keys);
      while ($item = db_fetch_object($result)) {
        $account = user_load(array('uid' => $item->uid));
        $results['results'][] = array(
          'title' => $account->name,
          'link' => url("user/$account->uid", NULL, NULL, TRUE),
          'snippet' => theme('user_picture', $account) . $account->info['about']
        );
      }
      return $results;
  }
}
